package com.gatekeep.ejb;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.ejb.Stateless;

@Stateless
public class GateBean implements GateRemote {

	Connection conn;
	PreparedStatement stmt;
	boolean failure=false;
	
	
	public GateBean() {
		try{
			
			Class.forName("com.ibm.db2.jcc.DB2Driver");
			
					
		}
		catch(Exception e){
		failure = true;	
		}

	
	}
	
	
	

	
	public String getPrisonersOut(String jno) {
		String ret=null;
		//int i=0;
		jno=queryValidate(jno);
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select pid from sch1.prisoner_io where jno=? and intime is null");
				stmt.setString(1,jno);
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{
					ret+="<option attr='"+rs.getString(1)+"'>"+rs.getString(1)+"</option>";
					
				}
				if(ret!=null)
					return ret;
				else
					return "No Staff is Inside";
				
			}
			else
			{
				return null;
			}
			
			}catch(Exception e){}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		
		return null;
	}

	public String getStaffsIn(String jno) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		String ret=null;
		//int i=0;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			if(failure==false) 
			{
				stmt=conn.prepareStatement("select id from sch1.staff_io where jno=? and outtime is null");
				stmt.setString(1,jno);
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{
					ret+="<option attr='"+rs.getString(1)+"'>"+rs.getString(1)+"</option>";
					
				}
				if(ret!=null)
					return ret;
				else
					return "No Staff is Inside";
				
			}
			else
			{
				return null;
			}
			
			}catch(Exception e){}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		
		return null;
	}

	
	
	public String getNonStaffsIn(String jno) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		String ret=null;
		//int i=0;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select name,intime,indate from sch1.nonstaff_io where jno=? and outtime is null");
				stmt.setString(1,jno);
								
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{
					ret+="<option attr='"+rs.getString(1)+"'>"+rs.getString(1)+"  |  "+rs.getString(3)+"  |  "+rs.getString(2)+"</option>";
					
				}
				if(ret!=null)
					return ret;
				else
					return "No Staff is Inside";
				
			}
			else
			{
				return null;
			}
			
			}catch(Exception e){}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		
		return null;
	}

	
	
	public String nonStaffIn(String jno, String staffid,String addr,String reason) {
		boolean in_or_not=false;
		jno=queryValidate(jno);
		staffid=queryValidate(staffid);
		addr=queryValidate(addr);
		reason=queryValidate(reason);
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select name,address from sch1.nonstaff_io where jno=? and outtime is null");
				stmt.setString(1,jno);
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{
					if((staffid.concat(addr)).equals(rs.getString(1)+rs.getString(2)))
					{
					in_or_not=true;	
					}
				}
				
				if(!in_or_not)
				{
				stmt=conn.prepareStatement("insert into sch1.nonstaff_io values(?,?,Current date,Current time,null,null,?,?)");
				stmt.setString(1,staffid);
				stmt.setString(2,jno);
				stmt.setString(3,addr);
				stmt.setString(4,reason);
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Staff Id May Be Wrongly Entered";
				}
				else
				{
					return "alreadyin";
				}
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Staff Id Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
	}

	public boolean nonStaffOut(String jno, String staffid) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		staffid=queryValidate(staffid);
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("update sch1.nonstaff_io set outtime=Current time,outdate=Current date where name=? and jno=?");
				stmt.setString(1,staffid);
				stmt.setString(2,jno);
				int no=stmt.executeUpdate();
				if(no>=1)
					return true;
				else
					return false;
				
			}
			else
			{
				return false;
			}
			
			}catch(Exception e){}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		
		return false;

	}

	public String prisonerIn(String jno, String staffid,String reason,String police) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		staffid=queryValidate(staffid);
		reason=queryValidate(reason);
		police=queryValidate(police);
		boolean in_or_not=false,valid_prisoner=false;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select pid from sch1.prisioner where jno=? and reldate>Current date");
				stmt.setString(1,jno);
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{
					if(staffid.equals(rs.getString(1)))
					{
					valid_prisoner=true;	
					}
				}
				if(valid_prisoner)
				{
				stmt=conn.prepareStatement("select pid from sch1.prisoner_io where jno=? and intime is null");
				stmt.setString(1,jno);
				rs=stmt.executeQuery();
				while(rs.next())
				{
					if(staffid.equals(rs.getString(1)))
					{
					in_or_not=true;	
					}
				}
				
				if(!in_or_not)
				{
				stmt=conn.prepareStatement("insert into sch1.prisoner_io values(?,?,Current date,Current time,null,null,?,?)");
				stmt.setString(1,staffid);
				stmt.setString(2,jno);
				stmt.setString(3,reason);
				stmt.setString(4,police);
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Prisoner Id May Be Wrongly Entered";
				}
				else
				{
					return "alreadyin";
				}
			
			}
			else
				return "<font color='black'><h3>Error : </h3></font><b>Prisoner Id May Be Wrongly Entered</b>";
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Prisoner Id Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

	}

	public boolean prisonerOut(String jno, String staffid) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		staffid=queryValidate(staffid);
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("update sch1.prisoner_io set intime=Current time,indate=Current date where pid=? and jno=?");
				
				stmt.setString(1,staffid);
				stmt.setString(2,jno);
				int no=stmt.executeUpdate();
				if(no>=1)
					return true;
				else
					return false;
				
			}
			else
			{
				return false;
			}
			
			}catch(Exception e){}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		
		return false;
	}

	public String queryValidate(String check_string)
	{
		check_string= check_string.replaceAll("<", " ");
	 	return check_string.replaceAll(">", " ");
	}	

	public String returnRecord(String jno) {
		jno=queryValidate(jno);
		int i=0;
		String info="\"info_abt_reg\"";
		// TODO Auto-generated method stub
		String ret="<div id='info_abt_reg' style='z-index:10;height:40px;width:40px;background-color:black;display:none;'></div><center><table cell-padding='10px' style='color:#600000;'><tbody>" +
				"<tr ><th>Staff-Registry</th><th>Non-Staff-Registry</th><th>Prisoners Who Are Out</th></tr>" +
				"<tr>" +
				"<td style='vertical-align:top;'><table border='2' id='rep_tab' style='border-collapse:collapse;color:#a00000;'><tbody>" +
				"" +
				" <tr><th style='background-image:url(images/header_bg2.png);'>Staff Id</th><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Time</th></tr>";
		//int i=0;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			if(failure==false)
			{
				stmt=conn.prepareStatement("select id,indate,intime,reason from sch1.staff_io where jno=? and outtime is null");
				stmt.setString(1,jno);
								
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{	
					i++;
					if(i%2==1)
						ret+="<tr style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td></tr>";
					else
						ret+="<tr style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td></tr>";
				}
				i=0;
				ret+="</tbody></table></td>" +
				"<td  style='vertical-align:top;'><table id='rep_tab' border='2' style='margin-left:10px;margin-right:10px;border-collapse:collapse;color:#a00000;'><tbody>" +
				" <th style='background-image:url(images/header_bg2.png);'>Staff Name</th><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Time</th></tr>";
				
				stmt=conn.prepareStatement("select name,indate,intime,reason from sch1.nonstaff_io where jno=? and outtime is null");
				stmt.setString(1,jno);
								
				 rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr onclick='' style='background-color:#F0F7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td></tr>";
					else
						ret+="<tr style='background-color:#F0F7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td></tr>";
			
					
				}
				ret+="</tbody></table></td>" +
				"<td  style='vertical-align:top;'><table border='2' id='rep_tab' style='border-collapse:collapse;color:#a00000;'><tbody>" +
				" <tr><th style='background-image:url(images/header_bg2.png);'>Prisoners Id</th><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Time</th></tr>";
				i=0;
				stmt=conn.prepareStatement("select pid,outdate,outtime,reason from sch1.prisoner_io where jno=? and intime is null");
				stmt.setString(1,jno);
								
				rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td></tr>";
					else
						ret+="<tr style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td></tr>";
			
					
				}
				
				ret+="</tbody></table></td></tr></tbody></table>";
				
				
				if(ret!=null)
					return ret;
				//else
					//return "No Staff is Inside";
				
			}
			else
			{
				return null;
			}
			
			}catch(Exception e){}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		return null;
	}

	public String staffIn(String jno, String staffid, String reason) {
		// TODO Auto-generated method stub
		boolean in_or_not=false,valid_staff=false;
		jno=queryValidate(jno);
		staffid=queryValidate(staffid);
		reason=queryValidate(reason);
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select id from sch1.staff1 where jno=?");
				stmt.setString(1,jno);
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{
					if(staffid.equals(rs.getString(1)))
					{
					valid_staff=true;	
					}
				}
				
				if(valid_staff)
				{
				stmt=conn.prepareStatement("select id from sch1.staff_io where jno=? and outtime is null");
				stmt.setString(1,jno);
				rs=stmt.executeQuery();
				while(rs.next())
				{
					if(staffid.equals(rs.getString(1)))
					{
					in_or_not=true;	
					}
				}
				
				if(!in_or_not)
				{
				stmt=conn.prepareStatement("insert into sch1.staff_io values(?,?,Current date,Current time,null,null,?)");
				stmt.setString(1,staffid);
				stmt.setString(2,jno);
				stmt.setString(3,reason);
				int no=stmt.executeUpdate();
					if(no>=1)
						return "true";
					else
						return "Staff Id May Be Wrongly Entered";
						
				}
				else
				{
					return "alreadyin";
				}
			  }
				else
					return "<font color='black'><h3>Error : </h3></font><b>Staff Id May Be Wrongly Entered</b>";
		    }
			else
			{
				return "false";
			}
			
			}catch(Exception e){return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Staff Id Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
		//return "false";
	}

	public boolean staffOut(String jno, String staffid) {
		// TODO Auto-generated method stub
		jno=queryValidate(jno);
		staffid=queryValidate(staffid);
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("update sch1.staff_io set outtime=Current time,outdate=Current date where id=? and jno=?");
				stmt.setString(1,staffid);
				stmt.setString(2,jno);
				int no=stmt.executeUpdate();
				if(no>=1)
					return true;
				else
					return false;
				
			}
			else
			{
				return false;
			}
			
			}catch(Exception e){}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		
		
		return false;
	}
	
	
	public String returnRecord1(String jno,String date)
	{
	int i=0;
		jno=queryValidate(jno);
		date=queryValidate(date);
		// TODO Auto-generated method stub
		String ret="<div id='info_abt_reg' style='z-index:10;height:40px;width:40px;background-color:black;display:none;'></div><center>" +
				"" +
				"<center><b>Staff-Registry&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab11)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:28px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab11'><table border='2' id='rep_tab11' bit='0' style='width:85%;border-collapse:collapse;color:#a00000;margin-top:10px;'><tbody>" +
				"" +
				" <tr><th style='background-image:url(images/header_bg2.png);'>Staff Id</th><th style='background-image:url(images/header_bg2.png);'>Reason</th><th style='background-image:url(images/header_bg2.png);'>In Time</th><th style='background-image:url(images/header_bg2.png);'>Out Date</th><th style='background-image:url(images/header_bg2.png);'>Out Time</th></tr>";
		//int i=0;
		try{
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
			
			if(failure==false)
			{
				stmt=conn.prepareStatement("select id,reason,intime,outdate,outtime from sch1.staff_io where jno=? and indate=?");
				stmt.setString(1,jno);
				stmt.setString(2,date);
								
				ResultSet rs=stmt.executeQuery();
				while(rs.next())
				{	
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab1' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab1' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
				}
				i=0;
				ret+="</tbody></table><br/><br/></div></center>" +
				"<center><b>NonStaff-Registry&nbsp;</b><img onclick='if(this.getAttribute(src1)==loc1)this.setAttribute(src1,loc);else{this.setAttribute(src1,loc1);}hider(rep_tab12)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab12'><table bit='0' id='rep_tab12' border='2' style='margin-top:10px;width:85%;margin-left:10px;margin-right:10px;border-collapse:collapse;color:#a00000;'><tbody>" +
				" <th style='background-image:url(images/header_bg2.png);'>Staff Name</th><th style='background-image:url(images/header_bg2.png);'>Reason</th><th style='background-image:url(images/header_bg2.png);'>In Time</th><th style='background-image:url(images/header_bg2.png);'>Out-Date</th><th style='background-image:url(images/header_bg2.png);'>Out-Time</th></tr>";
				
				stmt=conn.prepareStatement("select name,reason,intime,outdate,outtime from sch1.nonstaff_io where jno=? and indate=?");
				stmt.setString(1,jno);
				stmt.setString(2,date);
								
				 rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab2' style='background-color:#F0F7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab2' style='background-color:#F0F7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			
					
				}
				ret+="</tbody></table><br/><br/></div></center>" +
						"<center><b>Prisoners-Registry</b><img onclick='if(this.getAttribute(src1)==loc1){this.setAttribute(src1,loc);}else{this.setAttribute(src1,loc1);}hider(rep_tab13)' src='images/arrow-right1.gif' style='height:15;width:15;margin-left:20px;cursor:pointer;' /></center>" +
				"<center><div class='rep_tab13'><table border='2' bit='0' id='rep_tab13' style='margin-top:10px;width:85%;border-collapse:collapse;color:#a00000;'><tbody>" +
				" <tr><th style='background-image:url(images/header_bg2.png);'>Prisoners Id</th><th style='background-image:url(images/header_bg2.png);'>Date</th><th style='background-image:url(images/header_bg2.png);'>Out Time</th><th style='background-image:url(images/header_bg2.png);'>In Date</th><th style='background-image:url(images/header_bg2.png);'>In Time</th></tr>";
				i=0;
				stmt=conn.prepareStatement("select pid,reason,outtime,indate,intime from sch1.prisoner_io where jno=? and outdate=?");
				stmt.setString(1,jno);
				stmt.setString(2,date);
								
				rs=stmt.executeQuery();
				while(rs.next())
				{
					i++;
					if(i%2==1)
						ret+="<tr class='rep_tab3' style='background-color:#f0f7f9'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
					else
						ret+="<tr class='rep_tab3' style='background-color:#f0f7a6'><td>"+rs.getString(1)+"</td><td>"+rs.getString(2)+"</td><td>"+rs.getString(3)+"</td><td>"+rs.getString(4)+"</td><td>"+rs.getString(5)+"</td></tr>";
			
					
				}
				
				ret+="</tbody></table><br/><br/></div></center>";
				
				ret=ret.replaceAll("null","");
				
				if(ret!=null)
					return ret;
				//else
					//return "No Staff is Inside";
				
			}
			else
			{
				return "false";
			}
			
			}catch(Exception e){
				if((e.toString()).indexOf("datetime")!=-1)
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span><br/>2.&nbsp;Check Your Date Format ";
				else
					return "<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>";
				
				}
			finally{
				try {
					conn.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		return null;
	}
	
	

}
